import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

public class UDPTest {
	private static class Receiver extends Thread {
		DatagramSocket dsock;
		Receiver(DatagramSocket dsock) throws Exception {
			this.dsock = dsock;
			start();
		}
		public void run() {
			try {
				byte[] buf = new byte[4096];
				DatagramPacket dp = new DatagramPacket(buf, buf.length);
				while (true) {
					dsock.receive(dp);
					ReflectorPacket rp = new ReflectorPacket(dp);
					System.out.println("RECV=" + rp);
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}
	public static void main(String[] args) throws Exception {
		if (args.length < 3) {
			System.err.println(
				"usage: java UDPTest LOCALPORT SERVERNAME SERVERPORT");
			System.exit(0);
		}
		int local_port = Integer.parseInt(args[0]);
		InetAddress server_address = InetAddress.getByName(args[1]);
		int server_port = Integer.parseInt(args[2]);
		DatagramSocket dsock = new DatagramSocket(local_port);
		new Receiver(dsock);
		// packet 1
		byte[] buf = {
			0x10, 0x00
		};
		DatagramPacket dp = new DatagramPacket(buf, buf.length,
			server_address, server_port);
		dsock.send(dp);
		// packet 2
		byte[] buf2 = {
			0x11, 0x00, 0x00, 0x00, 0x01, 0x02, 0x03, 0x04
		};
		dp = new DatagramPacket(buf2, buf2.length,
			server_address, server_port);
		dsock.send(dp);
		// packet 3
		byte[] buf3 = {
			0x11, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0x03, 0x04
		};
		dp = new DatagramPacket(buf3, buf3.length,
			server_address, server_port);
		dsock.send(dp);
		// packet 4
		byte[] buf4 = {
			0x11, 0x00, 0x00, 0x01, 0x01, 0x01, 0x02, 0x03, 0x04
		};
		dp = new DatagramPacket(buf4, buf4.length,
			server_address, server_port);
		dsock.send(dp);
	}
}
